import time
import math

def sin1( int n ):
    cdef int i
    cdef double x, clc
    x = 0.0
    clc = time.time()
    for i in xrange( n ):
        x += math.sin( x )
    return time.time() - clc

cdef extern from "math.h":
    double sin( double )

def sin2( n ):
    x = 0.0
    clc = time.time()
    for i in xrange( n ):
        x += sin( x )
    return time.time() - clc
