#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys

if len( sys.argv ) > 1:  n = int( sys.argv[ 1 ] )
else: n = int( input( "число?: " ) )

try:               # Python 2
    factorial = lambda z: reduce( lambda x, y: x * y, range( 1, z + 1 ) )
    print( "n={} => n!={}".format( n, factorial( n ) ) )
except NameError:  # Python 3
    import functools
    factorial = lambda z: functools.reduce( lambda x, y: x * y, range( 1, z + 1 ) )
    print( "n={} => n!={}".format( n, factorial( n ) ) )

