# -*- coding: utf-8 -*-
import sys
import math
from sklearn import linear_model
from random import gauss

def func( x ) :                                  # линейная функция 3-х переменных
   f = 0.0
   for i in range( 0, n ) :
      f += k[ i ] * x[ i ]
   return f

r = 0.05                                         # отношение шум/сигнал
k = [ 0.33, 1.0, 2.5 ]
n = len( k ) 
x = [] ; y = []
if len( sys.argv ) > 1 : r = float( sys.argv[ 1 ] )
print( 'коэффициенты исходные: {}'.format( k ) )
for x1 in range( 0, n ) :
   for x2 in range( 0, n ) :
      for x3 in range( 0, n ) :
         x.append( ( float( x1 + 1 ), float( x2 + 1 ), float( x3 + 1 ) ) )
for z in x :
   y.append( func( z ) )
m = reduce( lambda x, y : x + y, y ) / len( y )  # среднее значение
if len( sys.argv ) > 2 : print( y )
for i in range( 0, len( y ) ) :
   y[ i ] += gauss( 0, m * r ) 
v = reduce( lambda x, y : x + y, y ) / len( y )  # среднее значение
regr = linear_model.LinearRegression()           # регрессионный объект
regr.fit( x, y )                                 # тренировать модель
print( 'коэффициенты регрессии: {}'.format( regr.coef_ ) )
z = regr.predict( x )
if len( sys.argv ) > 2 : print( z )
d = 0.0 
for i in range( 0, len( y ) ) :
   d += ( y[ i ] - z[ i ] ) * ( y[ i ] - z[ i ] )
print( 'СКО восстановленных данных = {}'.format( math.sqrt( d / len( y ) ) ) ) 

