# -*- coding: utf-8 -*-
from math import pi, sin
import matplotlib.pyplot as plt
from scipy.optimize import minimize

sin2 = lambda x: sin( pi / 2 * x[ 0 ] ** 2 ) * sin( pi / 2 * x[ 1 ] ** 2 ); 

X = [ ( 1, 1 ), ( 1, 1.7 ), ( 1.7, 1 ), ( 1.7, 1.7 ) ]
print( X )

Y = [ sin2( x ) for x in X ]
print( Y )

res = minimize( sin2, ( 1.4, 1.4 ), method='Nelder-Mead' )

print(  res.x )
print( res.fun )
print( '{} -> {}'.format( res.nit, res.nfev ) ) 

