#!/usr/bin/python3 -O
# -*- coding: utf-8 -*-

import time
import sys
import getopt
import os
import string
from multiprocessing import Pool

def fun( x ):
    time.sleep( 0.1 )
    return "{0}[{1}]".format( x * x, os.getpid() )

if __name__ == '__main__':
    procnum = 4
    argnum = 10
    try :
        opts, args = getopt.getopt( sys.argv[ 1: ], "p:n:" )
    except getopt.GetoptError :
        print( "недопустимая опция команды" )
        sys.exit( 2 )
    for opt, arg in opts :
        try:
            if opt[ 1: ] == 'p' : procnum = int( arg )
            if opt[ 1: ] == 'n' : argnum = int( arg )
        except ValueError :
            print( "недопустимое значение опции команды" )
            sys.exit( 3 )

    arg = [ x for x in range( argnum ) ]
    print( arg )
    pool = Pool( processes = procnum , )
    res = pool.map( fun, arg )
    print( res )

#    with Pool(processes=4) as pool:        # start 4 worker processes
#        result = pool.apply_async(f, [10]) # evaluate "f(10)" asynchronously
#        print(result.get(timeout=1))       # prints "100" unless your computer is *very* slow
#        print(pool.map(f, range(10)))      # prints "[0, 1, 4,..., 81]"
