#!/usr/bin/python -O
# -*- coding: utf-8 -*-

import getopt
import sys
import threading
import time

debuglevel = 0
threadnum = 2
delay = 1
active = 0

def delay_in_cycle( delay = 1.0 ):
    t = time.time()
    while time.time() - t < delay :
        pass

def thrfun( *args ):   
    st = time.time() - args[ 2 ]             # время старта потока
    ss = '\t{} : {} <= старт: {:14.11f}'. \
         format( args[ 1 ], threading.currentThread().getName(), st )
    if not active : time.sleep( args[ 0 ] )  # пауза 
    else : delay_in_cycle( args[ 0 ] )       # или активное ожидание
    st = time.time() - args[ 2 ]             # время завершения потока 
    print( '{} - финиш: {:14.11f}'.format( ss, st ) )
    return

opts, args = getopt.getopt( sys.argv[1:], "vt:d:a" )
for opt, arg in opts:     # опции (ключи) командной строки (-v, -t, -d, -a)
    if opt[ 1: ] == 'v' : debuglevel = debuglevel + 1
    if opt[ 1: ] == 't' : threadnum = int( arg )
    if opt[ 1: ] == 'd' : delay = int( arg )
    if opt[ 1: ] == 'a' : active = 1
if debuglevel > 0 :
    print( opts )
    print( args )
    print(  debuglevel )
    print(  threadnum )

threads = []
for n in range( threadnum ): # создание и запуск потоков
    parm = [ delay, n, 0 ]
    t = threading.Thread( target=thrfun, args=parm )
    threads.append( t )
    t.setDaemon( 1 )
    print( "\t{} : {} => запуск".format( n, t.getName() ) )
    parm[ 2 ] = time.time()
    t.start()
for n in range( threadnum ): # ожидание завершения всех потоков
    threads[ n ].join()
print( 'завершены все {} потоков, завершается ожидавший главный поток'.format( threadnum ) )
