#!/usr/bin/env python
# -*- coding: utf-8 -*-

import wx
import sys

class Frame(wx.Frame):

    def __init__(self, parent, id, title):
        print "Frame __init__"
        wx.Frame.__init__(self, parent, id, title)

class App(wx.App):

    def __init__(self, redirect=True, filename=None):
        print "App __init__"
        wx.App.__init__(self, redirect, filename)

    def OnInit(self):
        # Writing to stdout
        print "OnInit"
        # Creating the frame
        self.frame = Frame(parent=None, id=-1, title='Startup')
        self.frame.Show()
        self.SetTopWindow(self.frame)
        # Writing to stderr
        print >> sys.stderr, "A pretend error message"
        return True

    def OnExit(self):
        print "OnExit"

if __name__ == '__main__':
    # (1) Text redirection starts here
    app = App(redirect=True)
    print "before MainLoop"
    # (2) The main event loop is entered here
    app.MainLoop()
    print "after MainLoop"
