# -*- coding: utf-8 -*-

def multiplier( n ):    # замыкания - closure
    def mul( k ):
        return n * k
    return mul

mul3 = multiplier( 3 ) 

from functools import partial
def mulPart( a, b ):    # частичное применение функции
    return a * b

par3 = partial( mulPart, 3 )

class mulFunctor:       # эквивалентный функтор 
    def __init__( self, val1 ):
        self.val1 = val1
    def __call__( self, val2 ):
        return self.val1 * val2

fun3 = mulFunctor( 3 )

print( '{} . {} . {}'.format( mul3( 5 ), par3( 5 ), fun3( 5 ) ) )


