# -*- coding: utf-8 -*-
import sys
from math import exp, sin, pi, sqrt
from random import gauss
from scipy.optimize import minimize

#------------------------------------ модедирование ---------------------------
a = [ 1.0, 2, .7, 4., .2 ]                       # 4 параметра
x = [] ; y = []
r = 0.05                                         # отношение шум/сигнал
opfunc = lambda k, x : k[ 0 ] + \
                       k[ 1 ] * exp( -k[ 2 ] * x[ 0 ] ) + \
                       k[ 3 ] * sin( 2. * pi * k[ 4 ] * x[ 1 ] )

print( 'коэффциенты модели: {}'.format( a ) )
if len( sys.argv ) > 1 : r = float( sys.argv[ 1 ] )
for x1 in range( 0, 4 ) :
   for x2 in range( 0, 5 ) :
      x.append( ( float( x1 ), float( x2 ) ) )
for z in x :
   y.append( opfunc( a, z ) )
m = reduce( lambda x, y : x + y, y ) / len( y )  # среднее значение
for i in range( 0, len( y ) ) :
   y[ i ] += gauss( 0, m * r )
#------------------------------------ восстановление ------------------------
def delt( a ) :
   global d
   d = [ opfunc( a, z ) for z in x ]
   sum = 0.0
   for i in range( 0, len( y ) ) :
      sum += ( d[ i ] - y[ i ] ) ** 2
   return sum

b = ( 3.0, 1.0, 2.5, 2.0, .3 )
print( 'начальное приближение: {}'.format( b ) )
res = minimize( delt, b, method='Nelder-Mead' )
print( 'восстановленные коэффциенты: {}'.format( res.x ) )
print( 'рассогласование данных = {}'.format( sqrt( res.fun / len( y ) ) ) )
print( 'итераций {} -> вычислений функции {}'.format( res.nit, res.nfev ) )


